<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIPregelGraphLibrary: src/standard/modules/data_structures/pregel/PregelDataContainer_openMP.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIPregelGraphLibrary
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_2c9c37dba306fee5398d0d7fdd1d0656.html">src</a></li><li class="navelem"><a class="el" href="dir_64f0e38761748c48d17ab571aef88817.html">standard</a></li><li class="navelem"><a class="el" href="dir_678d789de5a35871f247169518f79ef5.html">modules</a></li><li class="navelem"><a class="el" href="dir_c5e3b00c8312136ba9efd809a03fd834.html">data_structures</a></li><li class="navelem"><a class="el" href="dir_8c8346c70c42ecdcdfc19a3ef314bfdc.html">pregel</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">PregelDataContainer_openMP.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * @file: PregelDataContainer_openMP.hpp</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * @ brief: contains implementation of the openMP pregel data container class</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  @author Mohamed Mansour</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  @date June 19, 2014</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef PREGELDATACONTAINER_OPENMP_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#define PREGELDATACONTAINER_OPENMP_HPP_</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#ifdef OPENMP_ENABLE</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;graph_traits.hpp&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="subgraph_8hpp.html">subgraph.hpp</a>&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="SysMessage_8hpp.html">TIGLCommunicationSysMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;pregel_macros.h&quot;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> CVertex, <span class="keyword">typename</span> MessageType&gt;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">class </span><a class="code" href="classPregelDataContainer.html">PregelDataContainer</a>:</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keyword">public</span> <a class="code" href="classSubgraph.html">TIGLContainersSubgraph</a>&lt;CVertex&gt;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keyword">typedef</span> graph_traits&lt;CVertex&gt; trait_type;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::ID_TYPE                            ID_TYPE;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::EDGE_TYPE                          EDGE_TYPE;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::FAST_LIST_TYPE                     VERTEX_LIST_TYPE;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::FAST_VERTEX_ITERATOR               VERTEX_ITERATOR;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">typedef</span> CVertex                                                 VERTEX_TYPE;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="comment">//typedef typename std::map&lt;ID_TYPE, uint32&gt;::iterator           INDEX_ITERATOR;</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> TIGLContainersSubgraph&lt;CVertex&gt;::INDEX_ITERATOR              INDEX_ITERATOR;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">typedef</span> vector&lt;MessageType&gt;                                     MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;MESSAGE_BUF_TYPE&gt;::iterator             MESSAGE_BUF_ITERATOR;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">typedef</span> MessageType                                             MESSAGE_TYPE;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> TIGLContainersSubgraph&lt;CVertex&gt;::POS_LIST_TYPE               POS_LIST_TYPE;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">public</span>: <span class="comment">//constructor/destructor</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <a class="code" href="classPregelDataContainer.html">PregelDataContainer</a>(<span class="keywordtype">bool</span> flagDirected, uint32 assignedHashSize = 0):</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <a class="code" href="classSubgraph.html">TIGLContainersSubgraph</a>&lt;CVertex&gt;(flagDirected, assignedHashSize)</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    {</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        evenTimeMessages = <span class="keyword">new</span> vector&lt;MESSAGE_BUF_TYPE&gt; [NUM_OMP_THREADS];</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        oddTimeMessages = <span class="keyword">new</span> vector&lt;MESSAGE_BUF_TYPE&gt; [NUM_OMP_THREADS];</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        oddMessageCount = <span class="keyword">new</span> vector&lt;uint32&gt; [NUM_OMP_THREADS];</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        evenMessageCount= <span class="keyword">new</span> vector&lt;uint32&gt; [NUM_OMP_THREADS];</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        reset();</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;}</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <a class="code" href="classPregelDataContainer.html">PregelDataContainer</a>(VERTEX_LIST_TYPE &amp; init_adj_list, <span class="keywordtype">bool</span> flagDirected, uint32 assignedHashSize = 0):</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <a class="code" href="classSubgraph.html">TIGLContainersSubgraph</a>&lt;CVertex&gt;(init_adj_list, flagDirected, assignedHashSize)</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        evenTimeMessages = <span class="keyword">new</span> vector&lt;MESSAGE_BUF_TYPE&gt; [NUM_OMP_THREADS];</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        oddTimeMessages  = <span class="keyword">new</span> vector&lt;MESSAGE_BUF_TYPE&gt; [NUM_OMP_THREADS];</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        oddMessageCount = <span class="keyword">new</span> vector&lt;uint32&gt; [NUM_OMP_THREADS];</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        evenMessageCount= <span class="keyword">new</span> vector&lt;uint32&gt; [NUM_OMP_THREADS];</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        reset();</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    }</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    ~<a class="code" href="classPregelDataContainer.html">PregelDataContainer</a>(){</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keyword">delete</span> [] evenTimeMessages;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keyword">delete</span> [] oddTimeMessages;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keyword">delete</span> [] oddMessageCount;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keyword">delete</span> [] evenMessageCount;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    }</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    vector&lt;MESSAGE_BUF_TYPE&gt; * evenTimeMessages;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    vector&lt;MESSAGE_BUF_TYPE&gt; * oddTimeMessages;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    vector&lt;uint32&gt; * oddMessageCount;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    vector&lt;uint32&gt; * evenMessageCount;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    map&lt;ID_TYPE, MESSAGE_BUF_TYPE&gt;  externalOutMessages; <span class="comment">// holds the output messages for the current SS</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    vector&lt;TIGLCommunicationSysMessage&gt;  evenTimeSysMessages;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    vector&lt;TIGLCommunicationSysMessage&gt;  oddTimeSysMessages;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">void</span> reset()</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    {</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <a class="code" href="classSubgraph.html#adb8befa9540eb7e1173c8c633bc4a626">TIGLContainersSubgraph&lt;VERTEX_TYPE&gt;::reset</a>();</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        resetMessageBuf();</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    }</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keywordtype">void</span> resetMessageBuf()</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    {</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">int</span> thread = 0;thread &lt; NUM_OMP_THREADS;thread++)</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        {</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            evenTimeMessages[thread].clear();</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            oddTimeMessages[thread].clear();</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            oddMessageCount[thread].clear();</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            evenMessageCount[thread].clear();</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        }</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        oddTimeSysMessages.clear();</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        evenTimeSysMessages.clear();</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    }</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordtype">void</span> init()</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    {</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">int</span> thread = 0; thread &lt; NUM_OMP_THREADS; thread ++)</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        {</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            <span class="keywordflow">for</span>(uint32 vertexCount= 0; vertexCount &lt; evenTimeMessages[thread].size(); vertexCount++)</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            {</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;                (evenTimeMessages[thread])[vertexCount].clear();</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;                (oddTimeMessages[thread])[vertexCount].clear();</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;            }</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            oddMessageCount[thread].assign(oddMessageCount[thread].size(), 0); <span class="comment">// resetting the number of messages</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;            evenMessageCount[thread].assign(evenMessageCount[thread].size(), 0); <span class="comment">// resetting the number of messages</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        }</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        oddTimeSysMessages.clear();</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        evenTimeSysMessages.clear();</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    }</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordtype">void</span> addVertex(CVertex &amp; x)</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    {</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <a class="code" href="classSubgraph.html#a47d20cbbcf0aa460c1eb4a0f3672faa8">TIGLContainersSubgraph&lt;CVertex&gt;::addVertex</a>(x);</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="comment">// adding to the message buffers</span></div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        MESSAGE_BUF_TYPE y;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">int</span> thread = 0 ; thread &lt; NUM_OMP_THREADS; thread++)</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        {</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            evenTimeMessages[thread].push_back(y);</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            oddTimeMessages[thread].push_back(y);</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            oddMessageCount[thread].push_back(0); <span class="comment">//</span></div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;            evenMessageCount[thread].push_back(0); <span class="comment">//</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        }</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    }</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <span class="keywordtype">void</span> addVertex(ID_TYPE <span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    {</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        CVertex x(<span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        addVertex(x);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    }</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordtype">bool</span> addVertex_consistent(CVertex &amp; x)</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    {</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordflow">if</span>(<a class="code" href="classSubgraph.html">TIGLContainersSubgraph&lt;CVertex&gt;::addVertex_consistent</a>(x) == <span class="keyword">false</span>)</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        <span class="comment">// adding to the message buffers</span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        MESSAGE_BUF_TYPE y;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">int</span> thread = 0 ; thread &lt; NUM_OMP_THREADS; thread++)</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        {</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            evenTimeMessages[thread].push_back(y);</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            oddTimeMessages[thread].push_back(y);</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;            oddMessageCount[thread].push_back(0); <span class="comment">//</span></div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            evenMessageCount[thread].push_back(0); <span class="comment">//</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        }</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    }</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordtype">bool</span> removeVertex(ID_TYPE &amp; <span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    {</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="comment">// subgraph::removeVertex</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="comment">//ID_TYPE arrInd = this-&gt;hash(id);</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="comment">//INDEX_ITERATOR it = ((this-&gt;verticesPos)[arrInd]).find(id);</span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        <span class="keyword">typename</span> POS_LIST_TYPE::iterator posIt = (this-&gt;verticesPos).begin()+ this-&gt;hash(<span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        INDEX_ITERATOR it = std::lower_bound(posIt-&gt;begin(), posIt-&gt;end(), id);</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        <span class="keywordflow">if</span>(it == posIt-&gt;end())<span class="comment">//if(it == ((this-&gt;verticesPos)[arrInd]).end())</span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>; <span class="comment">// vertex does not exist</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keywordflow">if</span>(it-&gt;getId() != id)</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        uint32 pos = it-&gt;getPos();      <span class="comment">//uint32 pos = it-&gt;second;</span></div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        (this-&gt;verticesList).erase((this-&gt;verticesList).begin() + pos );</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        posIt-&gt;erase(it);<span class="comment">//((this-&gt;verticesPos)[arrInd]).erase(it);</span></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="comment">// now removing the corresponding vertices</span></div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">int</span> thread = 0 ; thread &lt; NUM_OMP_THREADS; thread++)</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        {</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            evenTimeMessages[thread].erase(evenTimeMessages[thread].begin() + pos);</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            oddTimeMessages[thread].erase(oddTimeMessages[thread].begin() + pos);</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            oddMessageCount[thread].erase(oddMessageCount[thread].begin()+pos);</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            evenMessageCount[thread].erase(evenMessageCount[thread].begin()+pos);</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        }</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    }</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keywordtype">void</span> clearMessages(<span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    {</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keywordflow">for</span>(MESSAGE_BUF_ITERATOR it = oddTimeFlag? oddTimeMessages[thread].begin():evenTimeMessages[thread].begin();</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;                it != (oddTimeFlag? oddTimeMessages[thread].end():evenTimeMessages[thread].end()); ++it)</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            it-&gt;clear();</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keywordflow">if</span>(oddTimeFlag == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            oddMessageCount[thread].assign(oddMessageCount[thread].size(), 0);</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            evenMessageCount[thread].assign(evenMessageCount[thread].size(), 0);</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    }</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    <span class="keywordtype">void</span> clearAllMessages(<span class="keywordtype">bool</span> oddTimeFlag)</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    {</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        <span class="keywordflow">for</span>(<span class="keywordtype">int</span> thread = 0 ; thread &lt; NUM_OMP_THREADS; thread++)</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        {</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;            <span class="keywordflow">for</span>(MESSAGE_BUF_ITERATOR it = oddTimeFlag? oddTimeMessages[thread].begin():evenTimeMessages[thread].begin();</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;                    it != (oddTimeFlag? oddTimeMessages[thread].end():evenTimeMessages[thread].end()); ++it)</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;                it-&gt;clear();</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;            <span class="keywordflow">if</span>(oddTimeFlag == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                oddMessageCount[thread].assign(oddMessageCount[thread].size(), 0);</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;                evenMessageCount[thread].assign(evenMessageCount[thread].size(), 0);</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        }</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    }</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    <span class="keyword">inline</span> uint32 getNumMessages(uint32 index, <span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    {</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        <span class="keywordflow">return</span> oddTimeFlag == <span class="keyword">true</span> ? (oddMessageCount[thread])[index]:evenMessageCount[thread][index];</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    }</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    <span class="keyword">inline</span> uint32 * getNumMessagesPtr(uint32 index, <span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    {</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;        <span class="keywordflow">return</span> oddTimeFlag == <span class="keyword">true</span> ? &amp;((oddMessageCount[thread])[index]): &amp;((evenMessageCount[thread])[index]);</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    }</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    uint32 getTotalMessageCount(<span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    {</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        uint32 totalMessages = 0;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        <span class="keywordflow">for</span>(<span class="keyword">typename</span> vector&lt;uint32&gt;::iterator it = oddTimeFlag == <span class="keyword">true</span> ?</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;                    oddMessageCount[thread].begin():evenMessageCount[thread].begin();</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;                it != (oddTimeFlag == <span class="keyword">true</span> ? oddMessageCount[thread].end():evenMessageCount[thread].end());++it)</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;            totalMessages += *it; <span class="comment">// of any has nonzero messages</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="keywordflow">return</span> totalMessages;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    }</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="comment">//  bool checkMessageConsistency(bool oddTimeFlag)</span></div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;<span class="comment">//  {</span></div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;<span class="comment">//      VERTEX_ITERATOR itv = this-&gt;begin();</span></div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;<span class="comment">//      typename vector&lt;uint32&gt;::iterator itCount = oddTimeFlag == true ? oddMessageCount.begin():evenMessageCount.begin();</span></div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;<span class="comment">//      for(;itCount != (oddTimeFlag == true ? oddMessageCount.end():evenMessageCount.end());++itCount)</span></div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;<span class="comment">//      {</span></div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;<span class="comment">//          if(*itCount != itv-&gt;getNumDifferentNbr()) // of any has nonzero messages</span></div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;<span class="comment">//          {</span></div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;<span class="comment">//              cout&lt;&lt; &quot;error in checkMessageConsistency id &quot; &lt;&lt; itv-&gt;getId() &lt;&lt; &quot;: (&quot; &lt;&lt; *itCount &lt;&lt; &quot;, &quot; &lt;&lt;itv-&gt;getNumDifferentNbr() &lt;&lt; &quot;)&quot; &lt;&lt; endl;</span></div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;<span class="comment">//              return false;</span></div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;<span class="comment">//          }</span></div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;<span class="comment">//          ++itv;</span></div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="comment">//      }</span></div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="comment">//      return true;</span></div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="comment">//  }</span></div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;<span class="comment">//  inline bool checkMessageConsistency(uint32 index, bool oddTimeFlag)</span></div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;<span class="comment">//  {</span></div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;<span class="comment">//      typename vector&lt;uint32&gt;::iterator itCount = oddTimeFlag == true ?</span></div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;<span class="comment">//                                  oddMessageCount.begin():evenMessageCount.begin();</span></div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;<span class="comment">//      return *(itCount+index) == (this-&gt;begin()+index)-&gt;getNumDifferentNbr(); // of any has nonzero messages</span></div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;<span class="comment">//  }</span></div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> clearNumMessages(uint32 index, <span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    {</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        <span class="keywordflow">if</span>(oddTimeFlag == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            (oddMessageCount[thread])[index] = 0;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            (evenMessageCount[thread])[index] = 0;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    }</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> incrementNumMessages(uint32 index, <span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    {</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        <span class="keywordflow">if</span>(oddTimeFlag == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            (oddMessageCount[thread])[index]++;</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            (evenMessageCount[thread])[index]++;</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    }</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> setNumMessages(uint32 index, uint32 numMessages, <span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    {</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="keywordflow">if</span>(oddTimeFlag == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;            (oddMessageCount[thread])[index] = numMessages;</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            (evenMessageCount[thread])[index] = numMessages;</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    }</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> setAllNumMessages(uint32 index, uint32 numMessages, <span class="keywordtype">bool</span> oddTimeFlag)</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    {</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;        <span class="keywordflow">if</span>(oddTimeFlag == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;            <span class="keywordflow">for</span>(<span class="keywordtype">int</span> thread = 0; thread &lt; NUM_OMP_THREADS; thread++)</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;                (oddMessageCount[thread])[index] = numMessages;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            <span class="keywordflow">for</span>(<span class="keywordtype">int</span> thread = 0; thread &lt; NUM_OMP_THREADS; thread++)</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;                (evenMessageCount[thread])[index] = numMessages;</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;    }</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    <span class="keyword">inline</span> MESSAGE_BUF_TYPE * getIndexedMessageBuf(ID_TYPE index, <span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    {</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        <span class="keywordflow">return</span>  oddTimeFlag == <span class="keyword">true</span>? &amp;((oddTimeMessages[thread])[index]):&amp;((evenTimeMessages[thread])[index]);</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    }</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    <span class="keyword">inline</span> map&lt;ID_TYPE, uint32&gt; * getIndexMap()</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    {</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        <span class="keywordflow">return</span>  this-&gt;verticesPos;</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    }</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    <span class="keyword">inline</span> uint32 size()</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    {</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="keywordflow">return</span> (this-&gt;verticesList).size();</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    }</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    <span class="keyword">inline</span> vector&lt;MESSAGE_BUF_TYPE&gt; * getDataMessageBuf(<span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;    {</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        <span class="keywordflow">return</span> oddTimeFlag == <span class="keyword">true</span>? &amp;oddTimeMessages[thread]:&amp;evenTimeMessages[thread];</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    }</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    <span class="keywordtype">void</span> pushDataMessage(MESSAGE_TYPE &amp; message, uint32 index, <span class="keywordtype">bool</span> oddTimeFlag, <span class="keywordtype">int</span> thread)</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;    {</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;        <span class="keyword">typename</span> vector&lt;MESSAGE_BUF_TYPE&gt;::iterator activeMessageIterator =</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;                                    oddTimeFlag == <span class="keyword">true</span>?</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;                                    oddTimeMessages[thread].begin()+index:evenTimeMessages[thread].begin()+index;</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;        uint32 * numMessagesPtr = oddTimeFlag == <span class="keyword">true</span> ?</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                                        &amp;((oddMessageCount[thread])[index]):</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                                        &amp;((evenMessageCount[thread])[index]);<span class="comment">//getNumMessagesPtr(index, oddTimeFlag);//uint32 numMessages = getNumMessages(index, oddTimeFlag);</span></div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;        <span class="keywordflow">if</span>(activeMessageIterator-&gt;size() &lt;= *numMessagesPtr)</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;        {<span class="comment">// buffer size needs to be increased</span></div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;            activeMessageIterator-&gt;push_back(message);</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;        }</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        { <span class="comment">// rewrite in allocated area (no buffer enlargement)</span></div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;            activeMessageIterator-&gt;at(*numMessagesPtr) = message; <span class="comment">// assigning to an existing position</span></div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        }</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;        (*numMessagesPtr)++;<span class="comment">//incrementNumMessages(index, oddTimeFlag);</span></div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;    }</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keyword">inline</span> vector&lt;TIGLCommunicationSysMessage&gt; * getSysMessageBuf(<span class="keywordtype">bool</span> oddTimeFlag)</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    {</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        <span class="keywordflow">return</span> oddTimeFlag == <span class="keyword">true</span>? &amp;oddTimeSysMessages:&amp;evenTimeSysMessages;</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    }</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> isBiVertex()</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    {</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        <span class="keywordflow">return</span> ((this-&gt;verticesList).begin())-&gt;is_bivertex();</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    }</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    <span class="keyword">inline</span> map&lt;ID_TYPE, MESSAGE_BUF_TYPE&gt; * getOutMessageBuf()</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    {</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;        <span class="keywordflow">return</span> &amp;externalOutMessages;</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;    }</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;    uint32 memory_usage()</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    {</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;        uint32 totalSize = <a class="code" href="classSubgraph.html#ac571bc99100af1766fa6840dee1a5150">TIGLContainersSubgraph&lt;VERTEX_TYPE&gt;::memory_usage</a>();</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;        <span class="comment">// computing memory for the vertex list</span></div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;        uint32 sizeMessageBuff = <span class="keyword">sizeof</span>(vector&lt;MESSAGE_BUF_TYPE&gt;);</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        <span class="keywordflow">for</span>(VERTEX_ITERATOR it = this-&gt;begin(); it != this-&gt;end(); ++it)</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;        {</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;            uint32 vertexSize = <span class="keyword">sizeof</span>(MESSAGE_BUF_TYPE)*2; <span class="comment">// for the two buffers</span></div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;            vertexSize += it-&gt;getMessageBufSize(); <span class="comment">// for the input and output messages</span></div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;            sizeMessageBuff += vertexSize;</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;        }</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;        <span class="comment">// adding the overhead</span></div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;        sizeMessageBuff = (uint32)((<span class="keywordtype">double</span>)sizeMessageBuff*LIST_MEM_OVERHEAD);</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        totalSize += sizeMessageBuff;</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;        <span class="keywordflow">return</span> totalSize;</div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;</div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    }</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;};</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* Of OPENMP_ENABLE */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;</div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* PREGELDATACONTAINER_OPENMP_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classPregelDataContainer_html"><div class="ttname"><a href="classPregelDataContainer.html">PregelDataContainer</a></div><div class="ttdoc">Basic graph container for each core in pregel system. </div><div class="ttdef"><b>Definition:</b> PregelDataContainer.hpp:27</div></div>
<div class="ttc" id="classSubgraph_html_adb8befa9540eb7e1173c8c633bc4a626"><div class="ttname"><a href="classSubgraph.html#adb8befa9540eb7e1173c8c633bc4a626">TIGLContainersSubgraph::reset</a></div><div class="ttdeci">void reset()</div><div class="ttdoc">initialization procedure </div><div class="ttdef"><b>Definition:</b> subgraph.hpp:235</div></div>
<div class="ttc" id="classSubgraph_html_a47d20cbbcf0aa460c1eb4a0f3672faa8"><div class="ttname"><a href="classSubgraph.html#a47d20cbbcf0aa460c1eb4a0f3672faa8">TIGLContainersSubgraph::addVertex</a></div><div class="ttdeci">void addVertex(CVertex &amp;x)</div><div class="ttdoc">adding full defined vertex </div><div class="ttdef"><b>Definition:</b> subgraph.hpp:267</div></div>
<div class="ttc" id="subgraph_8hpp_html"><div class="ttname"><a href="subgraph_8hpp.html">subgraph.hpp</a></div></div>
<div class="ttc" id="SysMessage_8hpp_html"><div class="ttname"><a href="SysMessage_8hpp.html">TIGLCommunicationSysMessage.hpp</a></div><div class="ttdoc">contains core System Massage container class for Pregel </div></div>
<div class="ttc" id="classSubgraph_html"><div class="ttname"><a href="classSubgraph.html">TIGLContainersSubgraph</a></div><div class="ttdoc">core data container for a subgraph in each device </div><div class="ttdef"><b>Definition:</b> subgraph.hpp:105</div></div>
<div class="ttc" id="classSubgraph_html_ac571bc99100af1766fa6840dee1a5150"><div class="ttname"><a href="classSubgraph.html#ac571bc99100af1766fa6840dee1a5150">TIGLContainersSubgraph::memory_usage</a></div><div class="ttdeci">uint32 memory_usage()</div><div class="ttdoc">returns the overall memory usage of the graph in MB </div><div class="ttdef"><b>Definition:</b> subgraph.hpp:534</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 26 2014 16:59:25 for TIPregelGraphLibrary by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
